package com.usky.fire.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.common.core.bean.CommonPage;
import com.usky.fire.domain.AlarmFire;
import com.usky.fire.mapper.AlarmFireMapper;
import com.usky.fire.service.AlarmFireService;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.fire.service.util.OnlineMethod;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 火灾报警系统报警信息表 服务实现类
 * </p>
 *
 * @author JCB
 * @since 2022-07-29
 */
@Service
public class AlarmFireServiceImpl extends AbstractCrudService<AlarmFireMapper, AlarmFire> implements AlarmFireService {


//    @Override
    public CommonPage<AlarmFire> alarmFireList(List<String> deviceCodeList, Integer handlingStatus, String startDate, String endDate, Integer pageNum, Integer pageSize) {
        LambdaQueryWrapper<AlarmFire> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.in(AlarmFire::getDeviceCode,deviceCodeList);
        if (handlingStatus!=null){
            queryWrapper.eq(AlarmFire::getHandlingStatus,handlingStatus);
        }

        if (startDate!=null&&!"".equals(startDate)&&endDate!=null&&!"".equals(endDate)){
            queryWrapper.between(AlarmFire::getAlarmTime, startDate, endDate);
        }
        int total = this.count(queryWrapper);
        queryWrapper.orderByDesc(AlarmFire::getId);
        if (pageNum!=null&&pageNum!=0&&pageSize!=null&&pageSize!=0){
            Integer startFate = OnlineMethod.getStartFate(pageNum,pageSize);
            queryWrapper.last("limit "+startFate+",pageSize ");
        }
        List<AlarmFire> list = this.list(queryWrapper);
        return new CommonPage<>(list, total, pageSize,pageNum);
    }
}
